; These drive the baiter

Bait_Score	equ 100			; Score for pod

Bait_Speed	equ 880			;

Bait_Hits	equ 12			; Hit counts

Bait_Damage	equ 1			; Damage if collision

; Add one thing to the list

Create_1_Baiter:call Get_Free		; DI := ptr to free space
		jc C1B_Fail		; Failed

		; Now create a thing

		call Create_Bait	; Do it

		; Done, exit

C1B_Fail:	ret			; Done

; Generate a baiter

Create_Bait:	mov b cs:dSpeed[di],1	; Frame-rate
		mov b cs:dDelay[di],1	; Start immediately

		; Setup its shape

		mov b cs:dShape[di],26	; Thing sprite

		; Setup colours

		mov ax,0D09h		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0F0Bh		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],B_White ; Colour in map

		; Setup the dirn change timer

		mov w cs:dLife[di],1	 ; Timer

		; Setup it's hit points

		mov b cs:dHits[di],Bait_Hits ; This many

		; Setup it's shot routine

		mov w cs:dpShot[di],o Bait_Shot; Shot routine

		; Speed

		mov w cs:dTargSpeed[di],Bait_Speed ; Speed

		; Turn rate

		mov al,cs:optBait_D_R	; Turn rate
		mov cs:dTemp1[di],al	;

		; Vector

		mov w cs:ddX[di],0	; Not moving
		mov w cs:ddY[di],0	;

		; Position

		call Rand_X		; Giz a random X

		; Get its Y

		push ds			; Save
		push ax			;

		mov bx,o Mount_Ys	; Y defn
		add bx,ax		;

		mov ax,DATA		; Get the seg
		mov ds,ax		;

		mov dl,ds:[bx]		; Get the Y
		sub dl,5		; In the middle of the man

		pop ax			; Restore
		pop ds			;

		; Setup it's move routine

		mov cx,o Move_Bait	; Move routine

		; Setup it's implode

		mov bx,o Frag_Implode	; Implosion

		; Add it

		call Warp_In		; Warp it in

		; Exit

		ret			; Done

; Bait shot

Bait_Shot:	dec b cs:dCol1+1[si]	; Change

		jmp Thing_Shot		; As normal

; Bait killed

MBT_Shot:	mov ax,Bait_Score	; Score
		call Add_Score		;

		jmp MT_Shot		; Vector off

; Vectors

vMBT_PossHit:	jmp MBT_PossHit		; Vector
vMBT_NewDir:	jmp MBT_NewDir		;

; Move a Bait

Move_Bait:	test b cs:dFlags[di],080h; Hit ?
		jnz MBT_Shot		 ; Yes, skip

		; Have we hit the ship ?

		mov al,cs:Ship_Y	; The ship's Y
		sub al,3		; Widen it
		cmp al,cs:dBott[di]	; Get the highest possible Y
		jb vMBT_PossHit		; Yes, possible hit

		; Change dirn ?

MBT_NotHit:	call Rand_32		; Giz a random number
		cmp al,cs:optBFP	; Prob
		jnc MBT_NoFire		; Skip the fire code

		; Fire at the ship

		mov cl,7		; / 128
		shr ax,cl		; Velocity
		add ax,cs:Bait_Proj_Sp	;
		call Fire_At_Ship	; Shoot at it

		; Now move according to the state

MBT_NoFire:	mov ax,cs:dLife[di]	; Time to change dirn ?
		dec ax			;
		jz vMBT_NewDir		; Yes, skip

		mov cs:dLife[di],ax	; Save time

		; Change colour

	; Move it, using fractions

MBT_GotDir:	mov ax,cs:dTargdX[di]	; Target vector
		sub ax,cs:ddX[di]	; Current vector
		je MBT_GD_1		; Same, skip

		; Now, turn as a function of damage

		mov cl,cs:optBait_T	; /n

		sar ax,cl		;
		jnz MBT_GD_0a		; Skip nz

		mov ax,1		; At least 1

MBT_GD_0a:	add cs:ddX[di],ax	; Change it

MBT_GD_1:	mov ax,cs:dTargdY[di]	; Target vector
		sub ax,cs:ddY[di]	; Current vector
		je MBT_GD_2		; Same, skip

		sar ax,cl		;
		jnz MBT_GD_1a		; Skip nz

		mov ax,1		; At least 1

MBT_GD_1a:	add cs:ddY[di],ax	; Change it

		; Now move

MBT_GD_2:	mov bl,cs:ddX[di]	; Step in X
		mov al,cs:ddX+1[di]	;
		cbw			;

		add bl,cs:d_frac_X[di]	; Add it
		adc ax,cs:d_X[di]	;

		mov cs:d_frac_X[di],bl	; Save fractional X

		call Wrap_X		; Clip it

		mov cs:d_X[di],ax	; Save new X

		; Move it in Y

		mov ax,cs:ddY[di]	; Disp
		add ax,cs:d_frac_Y[di]	; Posn

		mov cs:d_frac_Y[di],al	; Save fraction

		mov al,ah		; Y

		; Clip Y

		cmp al,Max_Y-6		; Below bottom ?
		ja MBT_Y_Top		; Above

		cmp al,Min_Y+6		; Above top ?
		jae MBT_Y		; No, skip

		mov al,Max_Y-6		; Bottom
		jmp s MBT_Y		; Yes

MBT_Y_Top:	mov al,Min_Y+6		; Clip

MBT_Y:		mov cs:d_Y[di],al	; Save pos

		; Save the clipping Y's

		add al,4		; Bottom
		mov cs:dBott[di],al	;

		sub al,4+4		; Top
		mov cs:dTop[di],al	;

		; Draw it, etc

		jmp MT_Show		; Show it

; Time to change direction

MBT_NewDir:	mov al,cs:dTemp1[di]	; Time
		mov ah,0		;
		mov cs:dLife[di],ax	; Time to change

		; Now calc new vector
		; X

		mov bx,cs:Ship_X	; Target
		mov ax,cs:d_X[di]	; Our X
		call Calc_Offset	; Vector
		mov cx,ax		; Save

		; Add a random displacement

		call Rand_32		; Random
		cbw			;
		sar ax,1		;
		add cx,ax		;
		mov si,cx		;

		; Y

		mov al,cs:Ship_Y	; Target
		sub al,cs:d_Y[di]	; Our 
		cbw			; 16-bit
		mov bx,ax		; Save dY

		; Add a random displacement

		call Rand_32		; Random
		cbw			;
		sar ax,1		;/2
		add ax,bx		;
		mov bx,ax		;

		; Now, we must scale these to get the required speed.

		cmp cx,0		; dX +ve ?
		jns MBT_ND_1		; Yes, skip

		neg cx			; Abs dX

MBT_ND_1:	cmp ax,0		; dY +ve ?
		jns MBT_ND_2		; Yes, skip

		neg ax			; Abs dX

MBT_ND_2:	add cx,ax		; |dx| + |dY|
		inc cx			; NOT 0 !

		; Calc the scale speed

		mov ah,Bait_Hits	; This many to start with
		sub ah,cs:dHits[di]	; Target speed
		mov al,0		;
		add ax,ax		; * 2
		add ax,cs:dTargSpeed[di]; Base speed

		mov dx,0		; 32-bit

		div cx			; Calc 

		; Now scale the real dX/dY

		mov cx,ax		; Scale factor
		inc cx			; NOT ZERO !

		mov ax,si		; dX
		imul cx			; Scale it
		mov cs:dTargdX[di],ax	;

		mov ax,bx		; dY
		imul cx			; Scale it
		mov cs:dTargdY[di],ax	;

		; Done, skip

		jmp MBT_GotDir		; As above

	; Possible impact with the ship

MBT_PossHit:	add al,3+3		; Down
		cmp al,cs:dTop[di]	; Get the highest possible Y
		jb vMBT_NotHit		; No, not hit

		; The Y's are right, check the X's

		mov ax,cs:Ship_X	; The ship's position

		sub ax,16		; Back 11
		call Wrap_X		;
		mov cx,ax		;

		mov ax,cs:Ship_X	; The ship's position

		add ax,16		; Back 11
		call Wrap_X		;
		mov dx,ax		;

		mov ax,cs:d_X[di]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc MBTPH_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb vMBT_NotHit		; No, fail

		cmp ax,dx		; X in range ?
		ja vMBT_NotHit		; No, fail

		; Assume a hit

MBT_Hit:	mov al,Bait_Damage	; Dec the shields
		call Shield_Dec		;

		; Flag collision

		mov ax,cs:d_X[di]	; X
		add ax,cs:Ship_X	;
		sar ax,1		; /2
		call Wrap_X		;

		mov dl,cs:d_Y[di]	; Y
		mov dh,0		;
		add dl,cs:Ship_Y	;
		adc dh,0		;
		sar dx,1		; /2

		mov bx,o Frag_Explode_B	; Ptr to table
		call Gen_Frag		; Generate the fragments

		; Improve turn rate

		shr b cs:dTemp1[di],1	; Faster
		jnz vMBT_NotHit		; Not zero

		mov b cs:dTemp1[di],1	; Restore to 1

		jmp MBT_NotHit		; No other change

	; The Bait is at the end, alternate clip

MBTPH_CheckEnd:	cmp ax,dx		; X<RHS
		jb MBT_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja MBT_Hit		; Yes, skip 

		; Not hit, skip

vMBT_NotHit:	jmp MBT_NotHit		; Skip
