; These drive the landers

Land_Score	equ 10			; Score for lander

Land_Hits	equ 1;3			; Hit counts
Landed_Hits	equ 10			;

Land_Damage	equ 10			; Damage if collision

Muta_Speed	equ 100			;
Muta_Delta	equ 40			;

Muta_Turn	equ 3			;
Muta_Hits	equ 1;6			;
Muta_Damage	equ 10			;
Muta_Score	equ 100			; Mutant score

; Add a few landers

Create_4_Lander:mov cl,cs:opt_4_Cnt	; This many
		mov ch,0		;

C4L_Lp:		push cx			; Save
		call Create_1_Lander	; Make one
		pop cx			;

		loop C4L_Lp		; Loop

		ret			; Done

; Add a few mutants

Create_4_Mutants:mov cx,4		; This many

C4M_Lp:		push cx			; Save
		call Create_1_Mutant	; Make one
		pop cx			;

		loop C4M_Lp		; Loop

		ret			; Done

; Add one thing to the list

Create_1_Lander:call Get_Free		; DI := ptr to free space
		jc C1L_Fail		; Failed

		; Now create a thing

		call Create_Land	; Do it

		; Done, exit

C1L_Fail:	ret			; Done

; Add one mutant to the list

Create_1_Mutant:call Get_Free		; DI := ptr to free space
		jc C1L_Fail		; Failed

		; Generate a mutant

Create_Mut:	call Create_Land	; Create a lander

		jmp Make_Mutant		; Change to a mutant

; Generate a Lander

Create_Land:	mov b cs:dSpeed[di],1	; Frame-rate
		mov b cs:dDelay[di],1	; Start immediately

		; Setup it's fire prob.

		call Rand_32		; Giz a rand
		and al,0Fh		; 0 .. 15
		add al,cs:optLFP	;
		mov cs:dTemp2[di],al	; Save it

		; Setup its shape

		mov b cs:dShape[di],27	; Thing sprite

		; Setup colours

		mov ax,0901h		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0B07h		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],B_Green ; Colour in map

		; Setup the dirn change timer

		mov w cs:dLife[di],1	 ; Timer

		; Setup it's hit points

		mov b cs:dHits[di],Land_Hits ; This many

		; Setup it's shot routine

		mov w cs:dpShot[di],o Land_Shot; Shot routine

		; Vector

		call Rand_32		; Random
		mov dl,ah		; Save

		and ax,2		; 0 or 2
		dec ax			;
		mov cs:ddX[di],ax	; +/- 1

		; Y offset

		and dl,1Fh		; 0 .. 15
		mov cs:dTemp1[di],dl	; Save it

		; Position

		call Rand_X		; Giz a random X

		; Get its Y

		mov dl,Min_Y + 20	; Near the top

		; Setup it's move routine

		mov cx,o Move_Land	; Move routine

		mov b cs:dState[di],0	; State 0 to start with

		; Setup it's implode

		mov bx,o Frag_Implode	; Implosion

		; Add it

		call Warp_In		; Warp it in

		; Exit

		ret			; Done

; Land shot

Land_Shot:	jmp Thing_Shot		; As normal

; Land killed

MLD_Shot:	mov ax,Land_Score	; Score
		call Add_Score		;

		jmp MT_Shot		; Vector off

; Vectors

vMLD_PossHit:	jmp MLD_PossHit		; Vector

; Move a Land

Move_Land:	test b cs:dFlags[di],080h; Hit ?
		jnz MLD_Shot		 ; Yes, skip

		; Have we hit the ship ?

		mov al,cs:Ship_Y	; The ship's Y
		sub al,3		; Widen it
		cmp al,cs:dBott[di]	; Get the highest possible Y
		jb vMLD_PossHit		; Yes, possible hit

		; Check the state

MLD_NotHit:	call Rand_32		; Giz a random number
		cmp al,cs:dTemp2[di]	; Prob
		jnc MLD_NoFire		; Skip the fire code

		; Fire at the ship

		mov cl,7		; / 128
		shr ax,cl		; Velocity
		add ax,cs:Land_Proj_Sp	;


		call Fire_At_Ship	; Shoot at it

		; Now move according to the state

MLD_NoFire:	mov al,cs:dState[di]	; Giz the state

		cmp al,0		; 0 Wandering ?
		je ML_S0		; Yes, skip

		dec al			; 1 Landing ?
		je vML_S1		; Yes, skip

		dec al			; 2 Landed ?
		je vML_S2		; Yes, skip

		dec al			; 3 Got one ?
		je vML_S3		; Yes, skip

		; Draw it, etc

		jmp s ML_Show		; Show it

; Vectors

vML_S1:		jmp ML_S1		; Goto state 1
vML_S2:		jmp ML_S2		; Goto state 2
vML_S3:		jmp ML_S3		; Goto state 3

	; Wandering state

ML_S0:		mov ax,cs:ddX[di]	; Offset
		add ax,cs:d_X[di]	; Posn
		call Wrap_X		; Clip
		mov cs:d_X[di],ax	; Store

		mov bx,ax		; Dup X
		sub bx,Pad_Width/2-1	; LHS of pad
		and bl,1Fh		; Mod 32 ?
		je ML0_PossPad		; Possible pad

	; Get the average mountain height

ML0_NotPad:	push ds			; Save

		mov bx,o Mount_Ys	; Y defn
		add bx,ax		;

		mov ax,DATA		; Get the seg
		mov ds,ax		;

		mov cx,0		;
		mov ah,0		;

		mov cl,ds:-2[bx]	; Get the Y
		mov al,ds:2[bx]		;
		add cx,ax		;
		mov al,ds:-9[bx]	;
		add cx,ax		;
		mov al,ds:9[bx]		;
		add ax,cx		;

		shr ax,1		; / 4
		shr ax,1		;

		sub al,18		; Above them

		pop ds			;

		sub al,cs:dTemp1[di]	; Offset

		; Now, do we need to move up or down ?

ML_ToY:		sub al,cs:d_Y[di]	; Offset
		je ML_Show		; Ok, skip

		mov al,1		; Assume up

		jnc ML0_1		; Skip

		mov al,-1		; Down

ML0_1:		add cs:d_Y[di],al	; Move it

		; Show it

ML_Show:	mov al,cs:d_Y[di]	; Save pos

		; Save the clipping Y's

		add al,4		; Bottom
		mov cs:dBott[di],al	;

		sub al,4+4		; Top
		mov cs:dTop[di],al	;

		; Done

		jmp MT_Show		; Show it

	; Possibly a landing-pad, try it

ML0_PossPad:	mov bx,o Pad_List	; Point at the list

ML0PP_Lp:	mov cx,cs:[bx]		; End ?
		cmp cx,0		; 0 ?
		je ML0_NotPad		; No, skip

		cmp ax,cx		; This address ?
		je ML0PP_Pad		; Yes, skip

		lea bx,6[bx]		; Skip this pad

		jmp s ML0PP_Lp		; Loop

	; We are above a pad, is it free ?

ML0PP_Pad:	mov al,cs:3[bx]		; Get the pad occupied state
		and al,04h		; Someone here ?
		jnz ML0_NotPad		; Yes, ignore this pad

		; Should we land ?

		call Rand_32		; Prob.
		cmp al,64		; 25%
		jnc ML0_NotPad		; No, skip

		; We have this pad, flag used

		or b cs:3[bx],2		; Assert used

		; Save a ptr to it

		mov cs:dpPad[di],bx	; Save the pad

		inc b cs:dState[di]	; Go to state 1

		jmp ML0_NotPad		; Done

	; Possible impact with the ship

MLD_PossHit:	add al,3+3		; Down
		cmp al,cs:dTop[di]	; Get the highest possible Y
		jb vMLD_NotHit		; No, not hit

		; The Y's are right, check the X's

		mov ax,cs:Ship_X	; The ship's position

		sub ax,16		; Back 11
		call Wrap_X		;
		mov cx,ax		;

		mov ax,cs:Ship_X	; The ship's position

		add ax,16		; Back 11
		call Wrap_X		;
		mov dx,ax		;

		mov ax,cs:d_X[di]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc MLDPH_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb vMLD_NotHit		; No, fail

		cmp ax,dx		; X in range ?
		ja vMLD_NotHit		; No, fail

		; Assume a hit

MLD_Hit:	mov ax,cs:d_X[di]	; X
		add ax,cs:Ship_X	;
		sar ax,1		; /2
		call Wrap_X		;

		mov dl,cs:d_Y[di]	; Y
		mov dh,0		;
		add dl,cs:Ship_Y	;
		adc dh,0		;
		sar dx,1		; /2

		mov bx,o Frag_Explode_B	; Ptr to table
		call Gen_Frag		; Generate the fragments

		; Now, if we are landed, this is not the end

		cmp b cs:dState[di],2	; In state 2 ?
		je Ship_Hit_Landed	; Yes, hit the landed lander

		mov al,Land_Damage	; Dec the shields
		call Shield_Dec		;

		; Ooops, kill the lander
		
		jmp MT_Shot		; Kill the lander

	; Collision with a landed lander

Ship_Hit_Landed:mov al,Land_Damage/4	; Dec the shields
		call Shield_Dec		;

		; Done
		
		jmp MLD_NotHit		; Yes, pretend we were not hit

	; The Land is at the end, alternate clip

MLDPH_CheckEnd:	cmp ax,dx		; X<RHS
		jb MLD_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja MLD_Hit		; Yes, skip 

		; Not hit, skip

vMLD_NotHit:	jmp MLD_NotHit		; Skip

	; Lander state 1

ML_S1:		mov bx,cs:dpPad[di]	; Point at the pad

		or b cs:3[bx],2		; Refresh the occupied flag
		test b cs:3[bx],4	; Has someone landed ?
		jne ML1_Fail		; Yes, damn, back to state 1

		; Now, move down

		mov al,cs:2[bx]		; Pad Y
		sub al,5		; Back up

		; Down ?

		sub al,cs:d_Y[di]	; Offset
		je ML1_Landed		; Ok, skip

		inc b cs:d_Y[di]	; Move down

		; Show it

		jmp ML_Show		; Show it

	; We have landed, goto state 2

ML1_Landed:	mov b cs:dState[di],2	; State 2

		mov cs:4[bx],di		; Save a pointer to the lander

		; Give us lots of hits

		mov b cs:dHits[di],Landed_Hits ; This many

	; Fall into the next state

ML_S2:		mov bx,cs:dpPad[di]	; Point at the pad

		or b cs:3[bx],7		; Flag landed + delay

		jmp ML_Show		; Show it
		
	; Someone has gazumped us, fly away

ML1_Fail:	mov b cs:dState[di],0	; Back to state 0

		jmp ML0_NotPad		; As if the pad failed

	; We have grabbed a man (or men), we become a mutant

ML_S3:		mov bx,cs:dpPad[di]	; Point at the pad

		and b cs:3[bx],0F8h	; Remove the landed flag
		mov w cs:4[bx],0	; Kill the link back to the lander
		mov w cs:dpPad[di],0	; And to the pad

		; Move off

		call Make_Mutant	; Make this into a mutant

		; Now, show it

		jmp ML_Show		; Show the thing

	; Convert this to a mutant

Make_Mutant:	mov cs:dpMove[di],o Move_Muta ; Change the move routine

		; Setup colours

		mov ax,0E06h		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0C07h		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],B_Yellow ; Colour in map

		; Setup for the mutant code

		mov al,cs:optMuta_Look	; Time to look
		mov cs:dTemp1[di],al	;

		mov w cs:dLife[di],1	;

		mov w cs:dTargSpeed[di],Muta_Speed ; Speed

		mov w cs:ddX[di],0	; Not moving
		mov w cs:dTargdX[di],0	;

		mov w cs:ddY[di],0	;
		mov w cs:dTargdY[di],0	;

		mov b cs:d_frac_X[di],0	;
		mov b cs:d_frac_Y[di],0	;

		mov b cs:dHits[di],Muta_Hits ; The number of hits

		ret			; Done

; Find a free landing pad, return bx pointing at the pad, ax =X, dl = Y

Find_Free_Pad:	mov bx,o Pad_List - 6	; Point at the list of pads

		; Get the next free one

FFP_Lp:		lea bx,6[bx]		; Move forward

		mov ax,cs:[bx]		; X
		cmp ax,0		; End ?
		je FFP_Clear		; Yes, skip

		; Is this one free ?

		test b cs:3[bx],80h	; Free ?
		jne FFP_Lp		; No, loop

		; Use it

		mov dl,cs:2[bx]		; Y
		sub dl,5		;

		or b cs:3[bx],080h	; Assert used

		ret			; Done

	; Clear the list

FFP_Clear:	mov bx,o Pad_List - 6	; Point at the list of pads

		; Get the next free one

FFPC_Lp:	lea bx,6[bx]		; Move forward

		mov ax,cs:[bx]		; X
		cmp ax,0		; End ?
		je Find_Free_Pad	; Yes, try again

		; Is this one free ?

		and b cs:3[bx],7Fh	; Free it

		jmp s FFPC_Lp		; Loop

; Release the occupied flags

Release_Pads:	mov bx,o Pad_List - 6	; Point at the list of pads

		; Get the next free one

RP_Lp:		lea bx,6[bx]		; Move forward

		mov ax,cs:[bx]		; X
		cmp ax,0		; End ?
		je RP_X			; Yes, skip

		; Dec the count

		mov al,cs:3[bx]		; Get the count
		and al,07h		; Counter
		je RP_Lp		; Already 0, skip

		dec al			; Dec field
		mov cs:3[bx],al		;

		and al,07h		; Cnt = 0 ?
		jnz RP_Lp		; No, loop

		; This is now released, clear the pointers

		mov w cs:4[bx],0	; Kill the link ptr

		jmp s RP_Lp		; Loop

RP_X:		ret			; Done

; Mutant shot

Muta_Shot:	dec b cs:dCol1+1[si]	; Change

		jmp Thing_Shot		; As normal

; Mutant killed

MMT_Shot:	mov ax,Muta_Score	; Score
		call Add_Score		;

		jmp MT_Shot		; Vector off

; Vectors

vMMT_PossHit:	jmp MMT_PossHit		; Vector
vMMT_NewDir:	jmp MMT_NewDir		;

; Move a Mutant

Move_Muta:	test b cs:dFlags[di],080h; Hit ?
		jnz MMT_Shot		 ; Yes, skip

		; Have we hit the ship ?

		mov al,cs:Ship_Y	; The ship's Y
		sub al,3		; Widen it
		cmp al,cs:dBott[di]	; Get the highest possible Y
		jb vMMT_PossHit		; Yes, possible hit

		; Change dirn ?

MMT_NotHit:	call Rand_32		; Giz a random number
		cmp al,cs:optMFP	; Prob
		jnc MMT_NoFire		; Skip the fire code

		; Fire at the ship

		mov cl,6		; / 64
		shr ax,cl		; Velocity
		add ax,cs:Muta_Proj_Sp	;
		call Fire_At_Ship	; Shoot at it

		; Move it

MMT_NoFire:	mov ax,cs:dLife[di]	; Time to change dirn ?
		dec ax			;
		jz vMMT_NewDir		; Yes, skip

		mov cs:dLife[di],ax	; Save time

		; Change colour

	; Move it, using fractions

MMT_GotDir:	mov ax,cs:dTargdX[di]	; Target vector
		sub ax,cs:ddX[di]	; Current vector
		je MMT_GD_1		; Same, skip

		; Now, turn

		mov cl,cs:optMuta_Turn	; /n

		sar ax,cl		;
		jnz MMT_GD_0a		; Skip nz

		mov ax,1		; At least 1

MMT_GD_0a:	add cs:ddX[di],ax	; Change it

MMT_GD_1:	mov ax,cs:dTargdY[di]	; Target vector
		sub ax,cs:ddY[di]	; Current vector
		je MMT_GD_2		; Same, skip

		sar ax,cl		;
		jnz MMT_GD_1a		; Skip nz

		mov ax,1		; At least 1

MMT_GD_1a:	add cs:ddY[di],ax	; Change it

		; Now move

MMT_GD_2:	mov bl,cs:ddX[di]	; Step in X
		mov al,cs:ddX+1[di]	;
		cbw			;

		add bl,cs:d_frac_X[di]	; Add it
		adc ax,cs:d_X[di]	;

		mov cs:d_frac_X[di],bl	; Save fractional X

		call Wrap_X		; Clip it

		mov cs:d_X[di],ax	; Save new X

		; Move it in Y

		mov ax,cs:ddY[di]	; Disp
		add ax,cs:d_frac_Y[di]	; Posn

		mov cs:d_frac_Y[di],al	; Save fraction

		mov al,ah		; Y

		; Clip Y

		cmp al,Max_Y-6		; Below bottom ?
		ja MMT_Y_Top		; Above

		cmp al,Min_Y+6		; Above top ?
		jae MMT_Y		; No, skip

		mov al,Max_Y-6		; Bottom
		jmp s MMT_Y		; Yes

MMT_Y_Top:	mov al,Min_Y+6		; Clip

MMT_Y:		mov cs:d_Y[di],al	; Save pos

		; Save the clipping Y's

		add al,4		; Bottom
		mov cs:dBott[di],al	;

		sub al,4+4		; Top
		mov cs:dTop[di],al	;

		; Draw it, etc

		jmp MT_Show		; Show it

; Time to change direction

MMT_NewDir:	mov al,cs:dTemp1[di]	; Time
		mov ah,0		;
		mov cs:dLife[di],ax	; Time to change

		; Now calc new vector
		; X

		mov bx,cs:Ship_X	; Target
		mov ax,cs:d_X[di]	; Our X
		call Calc_Offset	; Vector
		mov cx,ax		; Save
		mov si,ax		;

		; Y

		mov al,cs:Ship_Y	; Target
		sub al,cs:d_Y[di]	; Our 
		cbw			; 16-bit
		mov bx,ax		; Save dY

		; Now, we must scale these to get the required speed.

		cmp cx,0		; dX +ve ?
		jns MMT_ND_1		; Yes, skip

		neg cx			; Abs dX

MMT_ND_1:	cmp ax,0		; dY +ve ?
		jns MMT_ND_2		; Yes, skip

		neg ax			; Abs dX

MMT_ND_2:	add cx,ax		; |dx| + |dY|
		inc cx			; NOT 0 !

		; Calc the scale speed

		mov ah,cs:dHits[di]	; This number decreases
		mov al,0		;
		shr ax,1		; / 2 
		add ax,cs:dTargSpeed[di]; Base speed
		add w cs:dTargSpeed[di],Muta_Delta ; Step the speed

		mov dx,0		; 32-bit

		div cx			; Calc 

		; Now scale the real dX/dY

		mov cx,ax		; Scale factor
		inc cx			; NOT ZERO !

		mov ax,si		; dX
		imul cx			; Scale it
		mov cs:dTargdX[di],ax	;

		mov ax,bx		; dY
		imul cx			; Scale it
		mov cs:dTargdY[di],ax	;

		; Done, skip

		jmp MMT_GotDir		; As above

	; Possible impact with the ship

MMT_PossHit:	add al,3+3		; Down
		cmp al,cs:dTop[di]	; Get the highest possible Y
		jb vMMT_NotHit		; No, not hit

		; The Y's are right, check the X's

		mov ax,cs:Ship_X	; The ship's position

		sub ax,16		; Back 11
		call Wrap_X		;
		mov cx,ax		;

		mov ax,cs:Ship_X	; The ship's position

		add ax,16		; Back 11
		call Wrap_X		;
		mov dx,ax		;

		mov ax,cs:d_X[di]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc MMTPH_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb vMMT_NotHit		; No, fail

		cmp ax,dx		; X in range ?
		ja vMMT_NotHit		; No, fail

		; Assume a hit

MMT_Hit:	mov al,Muta_Damage	; Dec the shields
		call Shield_Dec		;

		; Flag collision

		mov ax,cs:d_X[di]	; X
		mov dl,cs:d_Y[di]	; Y

		mov bx,o Frag_Explode_B	; Ptr to table
		call Gen_Frag		; Generate the fragments

		jmp MT_Shot		; Kill the mutant, don't score it !

	; The Mutant is at the end, alternate clip

MMTPH_CheckEnd:	cmp ax,dx		; X<RHS
		jb MMT_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja MMT_Hit		; Yes, skip 

		; Not hit, skip

vMMT_NotHit:	jmp MMT_NotHit		; Skip
