; Show the laser bolts

Drive_Lasers:	mov di,cs:pLasers	; Point at the laser bolt list

		mov ax,o pLasers-dpNext	; Point at this ptr
		mov cs:pPrev_Laser,ax	; Save this

		cmp di,0		; Any things ?
		jz DL_X			; No, exit

		; There are lasers

		or b cs:Action,2	; Flag that we did something

DL_Lp:		cmp di,0		; Valid ?
		jz DL_X			; No, skip

		; Dec it's life-time

		dec w cs:dLife[di]	; Decay it
		jz DL_End_TO		; Kill it

		; Now show this bolt

		call Move_Laser		; Move it
		jc DL_End		; Kill it, (explode)

		; Move onto the next

DL_Next:	mov cs:pPrev_Laser,di	; Save a ptr to it

		mov di,cs:dpNext[di]	; Next laser

		jmp DL_Lp		; Loop

	; Exit code, setup the un-draw operation

DL_X:		call Spk_Off		; Sound off

		ret			; Done

	; We must kill this laser bolt

DL_End:		mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Laser	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Explode it

		push ax			; Save

		mov ax,cs:d_X[si]	; X
		mov dl,cs:d_Y[di]	; Y

		mov bx,o Frag_Explode_S	; Small table
		call Gen_Frag		; Generate the fragments

		pop ax

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s DL_Lp		; Loop

	; Time it out

DL_End_TO:	mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Laser	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Explode it

		push ax			; Save

		mov ax,cs:d_X[di]	; X
		mov dl,cs:d_Y[di]	; Y

		mov bx,o Frag_Explode_SS; Very small table
		call Gen_Frag		; Generate the fragments

		pop ax

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s DL_Lp		; Loop

; Entry with di pointing at data

Move_Laser:	mov al,cs:ddX[di]	; Move it in X
		cbw			; 16-bit
		add ax,cs:d_X[di]	; Step it

		call Wrap_X		; Clip it

		mov cs:d_X[di],ax	; Save new X

		; Now, has this bolt hit anything ?

		mov bl,cs:d_Y[di]	; Our Y

		; Calc the LHS X, and RHS X

		mov ax,cs:d_X[di]	; Get the X
		mov dx,ax		; Save it

		sub ax,11		; Back 11 pels

		call Wrap_X		; Clip X

		mov cx,ax		; Save the LHS

		mov ax,dx		; Get the X
		add ax,11		; Forward 11 pels

		call Wrap_X		; Clip X

		mov dx,ax		; Save the RHS

		; Search for impacts

		mov si,cs:pThings	; Point at the creatures

		jmp s ML_Lp1		; Enter the loop

	; Try the next one

ML_Lp:		mov si,cs:dpNext[si]	; Point at the next one

ML_Lp1:		cmp si,0		; End ?
		je ML_X			; Yes, done

		; Try the Y's

		cmp cs:dTop[si],bl	; Y in range ?
		jae ML_Lp		; No, loop

		cmp cs:dBott[si],bl	; Y in range ?
		jb ML_Lp		; No, loop

		; Now try the X's

		mov ax,cs:d_X[si]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc ML_CheckEnd		; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb ML_Lp		; No, fail

		cmp ax,dx		; X in range ?
		ja ML_Lp		; No, fail

		; A hit, a palpable hit

ML_Hit:		mov bx,cs:dpShot[si]	; Call the hit routine

		call bx			; Call it

		; Explode the missile

ML_Test:	stc			; Kill it
		ret			;

	; The laser is at the end, alternate clip

ML_CheckEnd:	cmp ax,dx		; X<RHS
		jb ML_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja ML_Hit		; Yes, skip 

		; Loop

		jmp s ML_Lp		; Loop

	; Show this laser

ML_X:		call Draw_Thing		; Show it

		clc			; Ok
		ret			; Done

; Vars

		align 2			; Even

pPrev_Laser	dw 0			; Ptr to the last ptr