; These are the routines which move the objects around the arena.

; Init the vars concerning the player's ship

Init_Ship:	mov b cs:Ship_F_Cnt,1	; Start firing immediately

		mov w cs:Ship_LHS,0	; Clear the clips
		mov w cs:Ship_RHS,0	;
		mov w cs:Ship_TOP,0	;
		mov w cs:Ship_BOTT,0	;

		ret			; Exit

; This is the code which drives the player's ship around.

Move_Ship:	test b cs:optShipBurn,-1 ; Spew up ?
		jz MS_NS		; No, skip

		call ES_Frag		; Add a bit

MS_NS:		mov ax,0		; Default moves

		; Right ?

		test w cs:Key_Flags,kfRight ; Right ?
		jz MS_NR		; No, skip

		inc al			; Move right

		; Left ?

MS_NR:		test w cs:Key_Flags,kfLeft ; Left ?
		jz MS_NL		; No, skip

		dec al			; Move left

		; Up ?

MS_NL:		test w cs:Key_Flags,kfUp ; Up ?
		jz MS_NU		; No, skip

		dec ah			; Move up

		; Down ?

MS_NU:		test w cs:Key_Flags,kfDown ; Down ?
		jz MS_ND		; No, skip

		inc ah			; Move down

	; al = delta X, ah = delta Y

MS_ND:		cmp ax,0		; Any direction ?
		jz MS_Y_Done		; No, skip

		; Hit the action flag

		or b cs:Action,2	; Flag activity (ship)

		; Drive Y

		add ah,ah		; Up or down ?
		jz MS_Y_Done		; No, skip

		; Now, try to move in this direction

		add ah,cs:Ship_Y	; Add current posn.

		cmp ah,Max_Y		; Bottom (or Top)?
		ja MS_Y_Done		; Yes, stop

		cmp ah,Min_Y+8		; Top ?
		jb MS_Y_Done		; Yes, stop

		mov cs:Ship_Y,ah	; Store the new posn

		; Y done, now X

MS_Y_Done:	mov b cs:Thrust_F,0	; Assume no flames

		cmp al,0		; No X ?
		je MS_X_None		; No, skip dirn change

		; We have an X, drive the dirn flag

		mov cs:Ship_Dir,al	; Set it

		; Drive the thrust flames

		mov b cs:Thrust_F,1	; Flag flames

		; Now drive speed

MS_X_None:	cbw			; speed request -1,0,+1
		mov dx,ax		; Save it

		mov al,cs:Ship_Speed	; Get the speed
		cbw			;

		mov bx,ax		; Save it

		add bx,bx		; * 4
		add bx,bx		;			

		add bx,o Ship_Speed_Tab	; Point at table

		; Point at the speed change parameter fn(x keys)

		add bx,dx		; Point at speed/req. time size

		; Now determine pause value

		mov al,cs:Ship_S_Del	; Delay value
		add al,cs:[bx]		; Step delay

		jns MSX_NoChange	; We should change speed

		; We can change speed

MSX_Change:	mov b cs:Ship_S_Del,0	; Reset change delay

		; Now, which way to change speed ?

		cmp dx,0		; Is it a decay ?
		jz MSX_Decay		; Yes, move back to 0

		; No, move in the requested direction

		add cs:Ship_Speed,dl	; Move as required

		jmp MSX_Move		; Move it

	; This is a decay, move back towards 0

MSX_Decay:	mov al,cs:Ship_Speed	; Get ze speed
		cmp al,0		; Which way ?
		js MSX_D_L		; Moving left

		dec al			; Accelerate left
		dec al			;

MSX_D_L:	inc al			; Accelerate right

		mov cs:Ship_Speed,al	; New speed

		jmp MSX_Move		; Move it

	; Don't change the speed

MSX_NoChange:	mov cs:Ship_S_Del,al	; Store it

		; We must keep the present speed

MSX_Move:	mov al,cs:Ship_Speed	; Get the speed
		cbw			;
		cmp ax,0		; Set the flag
		jz MSX_M_1		; Skip it no move

		add ax,cs:Ship_X	; Now move in this dirn

		call Wrap_X		; Wrap it

		mov cs:Ship_X,ax	; Store it

		; Set action

		or b cs:Action,2	; Flag movement (ship)

		; Now, save the clip rectangle

MSX_M_1:	mov al,cs:Ship_Speed	; dX
		cbw			;

		cmp ax,0		; +ve ?
		jns MSX_M_2		; Yes, skip

		neg ax			; force +ve

MSX_M_2:	mov bx,ax		; Get it

		; Calc LHS

		mov ax,cs:Ship_X	; Get ze X

		sub ax,13		; Width/2
		sub ax,bx		;
		jns MSX_M2a		; +ve ?

		add ax,Total_Width	; Wrap it

MSX_M2a:	mov cs:Ship_LHS,ax	; Store it

		; Calc RHS

		mov ax,cs:Ship_X	; Get it

		add ax,13		; Width/2
		add ax,bx		;

		cmp ax,Total_Width	; In range ?
		jc MSX_M2b		; Yes, skip

		sub ax,Total_Width	; Wrap

MSX_M2b:	mov cs:Ship_RHS,ax	; Store it

		; Y

		mov al,cs:Ship_Y	; Middle
		sub al,3		; Up 3
		mov cs:Ship_TOP,al	;
		add al,3		; Down 3
		mov cs:Ship_BOTT,al	;
		
		; Now, is the fire key pressed ?

		test w cs:Key_Flags,kfFire ; Fire ?
		jz MS_NoFire		; No, skip

		dec b cs:Ship_F_Cnt	; Old state
		jnz MS_Done		; Skip

		mov al,cs:optSFC	; Get the rate
		mov cs:Ship_F_Cnt,al	; This often

		; Right, fire something

		call Get_Free		; Find a free space
		jc MS_NoFire		; Can't, exit

		; Set it to the ship's position

		; X

		mov ax,cs:Ship_X	; X
		mov cs:d_X[di],ax	;

		; Y

		mov al,cs:Ship_Y	; Y
		mov cs:d_Y[di],al	;

		; dX

		mov al,cs:Ship_Speed	; dX
		cbw			;

		; Sign ?

		cmp b cs:Ship_Dir,0	; +/-

		mov bx,12		; Speed
		jns MSX_1		; Pve 		

		neg bx			; -ve

MSX_1:		add ax,bx		; Add base speed

		mov cs:ddX[di],al	;

		; dY

		mov b cs:ddY[di],0	; Not yet

		; Shape

		mov b cs:dShape[di],11	; Laser shape

		; Alive

		or b cs:dFlags[di],11b	; Make it live, aimed at things

		; Colours

		mov al,cs:Frame_Cnt
		and al,4
		add al,11
		mov cs:dCol1[di],al	; Col 0

		; Setup life

		mov al,cs:optLas_Life	; Lifetime
		mov ah,0		;
		mov cs:dLife[di],ax	;

		; Dec the number of 'magnum' rounds

		mov ax,cs:Magnum_Shots	; This many
		cmp ax,0		; Any ?
		jnz MS_Fire_Mag		; Yes, skip

		; Add it to the list

MS_Fire_Add:	call Add_Laser		; Add it to the list

		; Done, exit

MS_Done:	ret			; Exit

MS_NoFire:	mov b cs:Ship_F_Cnt,1	; Start immediately

		ret			; Exit

	; Magnum shot

MS_Fire_Mag:	dec ax			; One less
		mov cs:Magnum_Shots,ax	;

		mov b cs:dShape[di],15	; Magnum laser shape
		
		; Setup magnum colours

		mov w cs:dCol1[di],0C0Fh; Colours

		jmp s MS_Fire_Add	; Add it

; Now, move the screen window if required

Move_Window:	test b cs:Ship_Dir,80h	; Which side ?

		mov ax,offR		; Assume RHS
		js MW_0			; Yes, skip

		mov ax,offL		; LHS

MW_0:		mov bx,cs:Wind_Offset	; Current offset

		sub ax,bx		; Are they the same ?
		je MW_Move		; Yes, skip

		; No, step in the right dirn

		js MW_1			; Skip

		; Are we close ?

		cmp ax,3		; Within 3 ?
		jb MW_0_Add_dX		; Yes, skip

		; Now we must increase the offset

		mov dx,0		;
		mov bx,16		; / 16
		div bx			; ax := disp

		cmp ax,3		; >3 ?
		ja MW_0a		; Skip

		mov ax,3		; 3

MW_0a:		add cs:Wind_Offset,ax	; Set new offset

		jmp s MW_Move		; Skip

	; We are near, add small disp.

MW_0_Add_dX:	inc w cs:Wind_Offset	; Small change

		jmp s MW_Move		; Skip

	; Now we must decrease the offset

MW_1:		neg ax			; Make it +ve

		; Are we close ?

		cmp ax,3		; Within 3 ?
		jb MW_1_Sub_dX		; Yes, skip

		mov dx,0		;
		mov bx,16		; / 16
		div bx			; ax := disp

		cmp ax,3		; >3 ?
		ja MW_1a		; Skip

		mov ax,3		; 3

MW_1a:		sub cs:Wind_Offset,ax	; Set new offset

		jmp s MW_Move		; Move it

	; We are near, sub small disp.

MW_1_Sub_dX:	dec w cs:Wind_Offset	; Small change

	; Move to this offset

MW_Move:	mov ax,cs:Wind_Offset	; Desired offset

		neg ax			; Wind = Ship - Off
		add ax,cs:Ship_X	; Get the ship's X offset

		call Wrap_X		; Wrap round arena

		mov cs:Scr_X,ax		; Set it

		ret			; Done

; Given pos a = ax, and pos b = bx return ax as offset from a to b

Calc_Offset:	sub ax,bx		; ax := ax - bx
		jns CO_Pos		; ax > bx

	; bx>ax

		neg ax			; bx > ax

		cmp ax,Total_Width/2	; Less than halfway ?
		jnc CO_a		; No

		ret			; Return D

CO_a:		sub ax,Total_Width	; Return D-Total

		ret

	; ax>bx

CO_Pos:		cmp ax,Total_Width/2	; Less than halfway
		jnc CO_b		; No, skip

		neg ax			; Return -D
		ret			;

CO_b:		neg ax			; Return Total-D
		add ax,Total_Width	;

		ret			;

; Given ax = X posn, wrap it into the arena

Wrap_X:		cmp ax,Total_Width	; Wrapped ?
		jnc WX_1		; No, skip

		ret			; OK, done

	; We are wrapped, LHS or RHS ?

WX_1:		cmp ax,0		; +ve or -ve
		js WX_LHS		; Off the left, skip

		; Move back to LHS

		sub ax,Total_Width	; Wrap

		ret			; Done

	; Move back to RHS

WX_LHS:		add ax,Total_Width	; Wrap

		ret			; Done

; Fixed data

; Table for ship's speeds

; The first number corresponds to accelerating left, the second number for no
; acceleration and the third for accelerating right.

; The fourth number defines the position of the window with respect to the ship

; The smaller the number, the longer it will take to move to the next speed.

; Each group of four numbers corresponds to an X step size (-9 to +9)

; WARNING !!! I don't think the above comments are entirely correct any longer !

		db  0,24,88,0		; - 12

		db  6,24,78,0		; - 11
		db  8,24,68,0		; - 10
		db 10,24,58,0		; - 9
		db 14,24,48,0		; - 8
		db 16,24,48,0		; - 7
		db 18,24,54,0		; - 6
		db 21,24,63,0		; - 5
		db 32,24,96,0		; - 4
		db 32,24,96,0		; - 3
		db 32,32,96,0		; - 2
		db 32,48,96,0		; - 1

		db 128
Ship_Speed_Tab	db 0
		db 128,0		;   0

		db 96,48,32,0		;   1
		db 96,32,32,0		;   2
		db 96,24,32,0		;   3
		db 96,24,32,0		;   4
		db 63,24,21,0		;   5
		db 54,24,18,0		;   6
		db 48,24,16,0		;   7
		db 48,24,14,0		;   8
		db 58,24,10,0		;   9
		db 68,24, 8,0		;  10
		db 78,24, 6,0		;  11

		db 88,24, 0,0		;  12

; Vars

		even

Magnum_Shots	dw ?			; Number of magnum shots, not used yet

Ship_LHS	dw ?			; LHS
Ship_RHS	dw ?			; RHS
Ship_TOP	db ?			; Min Y
Ship_BOTT	db ?			; Max Y

Ship_F_Cnt	db 0			; Delay for the fire key

		even

Wind_Offset	dw ?			; Offset from ship
